<template>
  <!-- <div v-if="!item.hidden && hasPower(item)"> -->
    <div v-if="!item.hidden">
    <template
      v-if="
        hasOneShowingChild(item.children, item) &&
        (!onlyOneChild.children || onlyOneChild.noShowingChildren) &&
        !item.alwaysShow
      "
    >
      <app-link v-if="onlyOneChild.meta" :to="resolvePath(onlyOneChild.path)">
        <el-menu-item
          :index="resolvePath(onlyOneChild.path)"
          :class="{ 'submenu-title-noDropdown': !isNest }"
        >
          <item
            :icon="onlyOneChild.meta.icon || (item.meta && item.meta.icon)"
            :title="onlyOneChild.meta.title"
          />
        </el-menu-item>
      </app-link>
    </template>

    <el-submenu
      v-else
      ref="subMenu"
      :index="resolvePath(item.path)"
      popper-append-to-body
    >
      <template slot="title">
        <item
          v-if="item.meta"
          :icon="item.meta && item.meta.icon"
          :title="item.meta.title"
        />
      </template>
      <sidebar-item
        v-for="child in item.children"
        :key="child.path"
        :is-nest="true"
        :item="child"
        :base-path="resolvePath(child.path)"
        class="nest-menu"
      />
    </el-submenu>
  </div>
</template>

<script>
import path from "path";
import { isExternal } from "@/utils/validate";
import Item from "./Item";
import AppLink from "./Link";
import FixiOSBug from "./FixiOSBug";
import { checkRole, checkVisitorType } from "@/utils/checkRole";

export default {
  name: "SidebarItem",
  components: { Item, AppLink },
  mixins: [FixiOSBug],
  props: {
    // route object
    item: {
      type: Object,
      required: true,
    },
    isNest: {
      type: Boolean,
      default: false,
    },
    basePath: {
      type: String,
      default: "",
    },
  },
  data() {
    // To fix https://github.com/PanJiaChen/vue-admin-template/issues/237
    // TODO: refactor with render function
    this.onlyOneChild = null;
    return {
      role: this.$store.getters.role,
      gateAuth: this.$store.getters.gateAuth,
      portAuth: this.$store.getters.portAuth,
      captureAuth: this.$store.getters.captureAuth,
      vehicleAuth: this.$store.getters.vehicleAuth,
      archivesAuth: this.$store.getters.archivesAuth,
      warningAuth: this.$store.getters.warningAuth,
      functionAuth: this.$store.getters.functionAuth,
      uavAuth: this.$store.getters.uavAuth,
      trafficLightsAuth: this.$store.getters.trafficLightsAuth,
      rainSnowAuth: this.$store.getters.rainSnowAuth,
      cockpitAuth: this.$store.getters.cockpitAuth,
    };
  },
  methods: {
    hasOneShowingChild(children = [], parent) {
      if (parent.children && parent.children.length > 1) {
        // console.log(parent.children, 55);
        children = parent.children;
      }
      const showingChildren = children.filter((item) => {
        if (item.meta.role.indexOf(this.$store.getters.role) < 0) {
          return false;
        }
        if (item.hidden) {
          return false;
        } else {
          // Temp set(will be used if only has one showing child)
          this.onlyOneChild = item;
          return true;
        }
      });
      // When there is only one child router, the child router is displayed by default
      if (showingChildren.length === 1) {
        return true;
      }

      // Show parent if there are no child router to display
      if (showingChildren.length === 0) {
        this.onlyOneChild = { ...parent, path: "", noShowingChildren: true };
        return true;
      }
      return false;
    },
    resolvePath(routePath) {
      if (isExternal(routePath)) {
        return routePath;
      }
      if (isExternal(this.basePath)) {
        return this.basePath;
      }
      return path.resolve(this.basePath, routePath);
    },
    hasPower(item) {
      // console.log(item);
      if (
        !this.gateAuth &&
        !this.portAuth &&
        !this.captureAuth &&
        !this.vehicleAuth &&
        item.path == "/personnelCarRecord"
      ) {
        return false;
      } else if (!this.gateAuth && item.path == "personnelGateRecord") {
        return false;
      } else if (!this.portAuth && item.path == "personnelCaptureRecord") {
        return false;
      } else if (!this.captureAuth && item.path == "personnelPortRecord") {
        return false;
      } else if (!this.vehicleAuth && item.path == "carCaptureRecord") {
        return false;
      } else if (!this.archivesAuth && item.path == "/personnelFiles") {
        return false;
      } else if (!this.warningAuth && item.path == "/personnelCarWarning") {
        return false;
      } else if (!this.functionAuth && item.path == "/functionAuth") {
        return false;
      } else if (!this.uavAuth && item.path == "uavAuth") {
        return false;
      } else if (!this.trafficLightsAuth && item.path == "trafficLightsAuth") {
        return false;
      } else if (!this.rainSnowAuth && item.path == "rainSnowAuth") {
        return false;
      } else if (
        (item.path == "/personnelCarRecord" ||
          item.path == "/personnelCarWarning") &&
        this.role == 1
      ) {
        return false;
      } else if (
        item.path == "personnelWarningManage" &&
        (this.role == 3 || this.role == 4)
      ) {
        return false;
      } else if (
        item.path == "carWarningManage" &&
        (this.role == 3 || this.role == 4)
      ) {
        return false;
      } else {
        return true;
      }
    },
  },
};
</script>
